/*
 * CS106X, Nick Troccoli, written and presented by Zach Birnholz
 * This class implements a HashSet for integers using
 * separate chaining for collision resolution.
 */

#pragma once

#include <string>
#include <sstream>
#include <iostream>
#include <iomanip>

class SeparateChainingHashSet {
public:
    SeparateChainingHashSet(int capacity = 10);
    ~SeparateChainingHashSet();

    void add(int elem);
    bool contains(int elem) const;
    void remove(int elem);
    void clear();
    int size() const;
    std::string toString() const;

    void printStructure() const;

private:
    struct HashNode {
        int data;
        HashNode* next;

        HashNode(int newData, HashNode* newNext = nullptr) {
            data = newData;
            next = newNext;
        }
    };

    const double MAX_LOAD_FACTOR = 0.75;

    HashNode** elems;
    int currSize;
    int capacity;

    void rehash();
    int getIndex(int elem) const;
    int hashCode(int elem) const;
    double loadFactor() const;
};

